/*
 * Copyright (c) 2019 - Manifold Systems LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package manifold.xml.api;

import java.util.Collections;
import java.util.List;
import manifold.api.host.IModule;
import manifold.api.json.AbstractJsonTypeManifold;

/**
 */
public class XmlTypeManifold extends AbstractJsonTypeManifold<XmlModel>
{
  @SuppressWarnings("WeakerAccess")
  public static final List<String> FILE_EXTENSION = Collections.singletonList( "xml" );

  @Override
  public void init( IModule module )
  {
    init( module, ( fqn, files ) -> new XmlModel( getModule().getHost(), fqn, files ) );
  }

  @Override
  public boolean handlesFileExtension( String fileExtension )
  {
    return FILE_EXTENSION.contains( fileExtension );
  }
}